#include <Windows.h>

//
// Ansi Console Functions
//

extern "C" int __cdecl printf(const char *format, ...)
{
	int ret;
	DWORD BW;
	va_list arglist;

	// Allocate the buffer dinamically to reduce size

	char *Buf = (char *) HeapAlloc(GetProcessHeap(), 0, 2048);

	va_start(arglist, format);

	ret = wvsprintfA(Buf, format, arglist);

	va_end(arglist);

	WriteConsoleA(GetStdHandle(STD_OUTPUT_HANDLE), Buf, ret, &BW, NULL);

	HeapFree(GetProcessHeap(), 0, Buf);

	return ret;
}

extern "C" int __cdecl puts(const char *Str)
{
	DWORD BW;

	WriteConsoleA(GetStdHandle(STD_OUTPUT_HANDLE), Str, lstrlenA(Str), &BW, NULL);

	return (int) BW;
}

extern "C" char * __cdecl gets(char *Buf)
{
	DWORD BR;

	ReadConsoleA(GetStdHandle(STD_INPUT_HANDLE), Buf, 512 /* arbitrary */, &BR, NULL);

	Buf[BR - 1] = 0;

	return Buf;
}

extern "C" int __cdecl getchar(void)
{
	DWORD BR;
	char c;

	ReadConsoleA(GetStdHandle(STD_INPUT_HANDLE), &c, 1, &BR, NULL);

	return (int) c;
}

//
// Secure Ansi Console Functions
//

extern "C" char * __cdecl gets_s(__out_ecount_z(_Size) char *Buf, size_t Size)
{
	DWORD BR;

	ReadConsoleA(GetStdHandle(STD_INPUT_HANDLE), Buf, (DWORD) (Size - 1), &BR, NULL);

	Buf[BR - 1] = 0;

	return Buf;
}

//
// Unicode Console Functions
//

extern "C" int __cdecl wprintf(const wchar_t *format, ...)
{
	int ret;
	DWORD BW;
	va_list arglist;

	// Allocate the buffer dinamically to reduce size

	wchar_t *Buf = (wchar_t *) HeapAlloc(GetProcessHeap(), 0, 2048 * sizeof (wchar_t));

	va_start(arglist, format);

	ret = wvsprintfW(Buf, format, arglist);

	va_end(arglist);

	WriteConsoleW(GetStdHandle(STD_OUTPUT_HANDLE), Buf, ret, &BW, NULL);

	HeapFree(GetProcessHeap(), 0, Buf);

	return ret;
}

extern "C" int __cdecl _putws(__in_z const wchar_t *Str)
{
	DWORD BW;

	WriteConsoleW(GetStdHandle(STD_OUTPUT_HANDLE), Str, lstrlenW(Str), &BW, NULL);

	return (int) BW;
}

extern "C" wchar_t * __cdecl _getws(wchar_t *Buf)
{
	DWORD BR;

	ReadConsoleW(GetStdHandle(STD_INPUT_HANDLE), Buf, 512 /* arbitrary */, &BR, NULL);

	Buf[BR - 1] = 0;

	return Buf;
}

extern "C" int __cdecl getwchar(void)
{
	DWORD BR;
	wchar_t c;

	ReadConsoleW(GetStdHandle(STD_INPUT_HANDLE), &c, 1, &BR, NULL);

	return (int) c;
}

//
// Secure Unicode Console Functions
//

extern "C" wchar_t * __cdecl _getws_s(wchar_t *Buf, size_t SizeInWords)
{
	DWORD BR;

	ReadConsoleW(GetStdHandle(STD_INPUT_HANDLE), Buf, (DWORD) (SizeInWords - 1), &BR, NULL);

	Buf[BR - 1] = 0;

	return Buf;
}